<?php
/**
 * @brief		Points
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Members Shop
 * @since		05 Jun 2019
 */

namespace IPS\membersshop\extensions\nexus\Item;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Points
 */
class _Points extends \IPS\nexus\Invoice\Item\Charge // or \IPS\nexus\Invoice\Item\Purchase
{
	/**
	 * @brief	Application
	 */
	public static $application = 'membersshop';
	
	/**
	 * @brief	Application
	 */
	public static $type = 'points';
	
	/**
	 * @brief	Icon
	 */
	public static $icon = 'star';
	
	/**
	 * @brief	Title
	 */
	public static $title = 'ms_points_purchase';
	
	/**
	 * @brief	Can use coupons?
	 */
	public static $canUseCoupons = TRUE;
	
	/**
	 * @brief	Can use account credit?
	 */
	public static $canUseAccountCredit = TRUE;
	
	/**
	 * On Paid
	 *
	 * @param	\IPS\nexus\Invoice	$invoice	The invoice
	 * @return	void
	 */
	public function onPaid( \IPS\nexus\Invoice $invoice )
	{
		$memberPoints = $invoice->member->shopPoints();
		$invoiceExtra = $invoice->status_extra;
		$pointsPurchased = $invoiceExtra['points'];
		$message = "Purchased Points";
		$invoice->member->addPoints( $pointsPurchased, $message );
	}
	
	// Other actions available. See the class you are extending for more information
}