//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_CalendarEvent extends _HOOK_CLASS_
{
	protected function processAfterCreate( $comment, $values )
	{
		try
		{
			parent::processAfterCreate( $comment, $values );
	        
			if( !\IPS\Settings::i()->ms_disable_calendar_hooks )
			{
				$member = \IPS\Member::loggedIn();
				try
				{
					$points = \IPS\membersshop\Calendar\Points::load( $this->container()->id, 'c_id' )->points_for_event;
				}
				catch ( \OutOfRangeException $e )
				{
					$points = 0;
				}
				if ( $points != 0 AND \IPS\Member::loggedIn()->member_id )
				{
					$pointsName = \IPS\Settings::i()->ms_points_name;
					
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_calendar_event'), $this->url(), $this->title );
					$member->addPoints( $points, $logsACP );
					
					$reward = new \IPS\membersshop\Rewards;
					$reward->item_id = -9;
					$reward->member_id = $member->member_id;
					$reward->time_date = time();
					$reward->reward = $points;
					$reward->save();
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
