//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_ClubsHook extends _HOOK_CLASS_
{
	protected function join()
	{
		try
		{
		    try
			{
				if( !\IPS\Settings::i()->ms_disable_clubs_hooks )
				{
					$member = \IPS\Member::loggedIn();
					if ( \IPS\Settings::i()->ms_clubs_enable )
					{
						$points = \IPS\Settings::i()->ms_clubs_join;
						if ( $points )
						{
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_joined_club'), $this->club->url(), $this->club->name );
							$member->addPoints( $points, $logsACP );
						}
					}
				}
			  	return \call_user_func_array( 'parent::join', \func_get_args() );
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	protected function leave()
	{
		try
		{
			try
			{
				if( !\IPS\Settings::i()->ms_disable_clubs_hooks )
				{
					$member = \IPS\Member::loggedIn();
					if ( \IPS\Settings::i()->ms_clubs_enable )
					{
						$points = \IPS\Settings::i()->ms_clubs_leave;
						if ( $points )
						{
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_left_club'), $this->club->url(), $this->club->name );
							$member->removePoints( $points, $logsACP );
						}
					}
				}
			  	return \call_user_func_array( 'parent::leave', \func_get_args() );
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	protected function removeMember()
	{
		try
		{
			try
			{
				if( !\IPS\Settings::i()->ms_disable_clubs_hooks )
				{
					$member = \IPS\Member::load( \IPS\Request::i()->member );
					if ( \IPS\Settings::i()->ms_clubs_enable )
					{
						$points = \IPS\Settings::i()->ms_clubs_leave;
						if ( $points )
						{
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_kicked_club'), $this->club->url(), $this->club->name );
							$member->removePoints( $points, $logsACP );
						}
					}
				}
			  	return \call_user_func_array( 'parent::removeMember', \func_get_args() );
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
