//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_DownloadsReview extends _HOOK_CLASS_
{
	public function postCreate()
	{
		try
		{
			\call_user_func_array( 'parent::postCreate', \func_get_args() );
			
			if( !\IPS\Settings::i()->ms_disable_downloads_hooks )
			{
				$member = \IPS\Member::loggedIn();
				try
				{
					$points = \IPS\membersshop\Downloads\Points::load( $this->container()->id, 'cat_id' )->points_for_review;
				}
				catch ( \OutOfRangeException $e )
				{
					$points = 0;
				}
				if ( $points != 0 AND \IPS\Member::loggedIn()->member_id )
				{
					$pointsName = \IPS\Settings::i()->ms_points_name;
					$getFile = \IPS\downloads\File::load( $this->fid );
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_file_review'), $getFile->url(), $getFile->name, $this->url() );
					$member->addPoints( $points, $logsACP );
					
					$reward = new \IPS\membersshop\Rewards;
					$reward->item_id = -7;
					$reward->member_id = $member->member_id;
					$reward->time_date = time();
					$reward->reward = $points;
					$reward->save();
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
