//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_GalleryComment extends _HOOK_CLASS_
{
	public function postCreate()
	{
		try
		{
			\call_user_func_array( 'parent::postCreate', \func_get_args() );
			
			if( !\IPS\Settings::i()->ms_disable_gallery_hooks )
			{
				$member = \IPS\Member::loggedIn();
				$item	= $this->item();
				
				try
				{
					$points = \IPS\membersshop\Gallery\Points::load( $item->category_id, 'c_id' )->points_for_comment;
				}
				catch ( \OutOfRangeException $e )
				{
					$points = 0;
				}
				
				if ( $points != 0 AND \IPS\Member::loggedIn()->member_id )
				{
					$pointsName = \IPS\Settings::i()->ms_points_name;
					$getImage = \IPS\gallery\Image::load( $this->img_id );
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_gallery_comment'), $getImage->url(), $getImage->caption, $this->url() );
					$member->addPoints( $points, $logsACP );
					
					$reward = new \IPS\membersshop\Rewards;
					$reward->item_id = -21;
					$reward->member_id = $member->member_id;
					$reward->time_date = time();
					$reward->reward = $points;
					$reward->save();
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
