//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_GallerySubmit extends _HOOK_CLASS_
{
	public function processUploads( $values, $url, $data )
	{
		try
		{
			$return = parent::processUploads( $values, $url, $data );
			
			if( !\IPS\Settings::i()->ms_disable_gallery_hooks )
			{
				$member = \IPS\Member::loggedIn();
				
				try
				{
					$getAmount = \IPS\membersshop\Gallery\Points::load( \IPS\Request::i()->category, 'c_id' )->points_for_upload;
					if( \IPS\Settings::i()->ms_gallery_multiply_points )
					{
						$points = \count( $values['images'] ) * $getAmount;
					}
					else
					{
						$points = $getAmount;
					}
				}
				catch ( \OutOfRangeException $e )
				{
					$points = 0;
				}
				
				if ( $points != 0 AND \IPS\Member::loggedIn()->member_id )
				{
					if( \count( $values['images'] ) > 1 )
					{
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_gallery_upload_multiple'), \count( $values['images'] ) );
					}
					else
					{
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_gallery_upload') );
					}
					$pointsName = \IPS\Settings::i()->ms_points_name;
					$member->addPoints( $points, $logsACP );
					
					$reward = new \IPS\membersshop\Rewards;
					$reward->item_id = -20;
					$reward->member_id = $member->member_id;
					$reward->time_date = time();
					$reward->reward = $points;
					$reward->save();
				}
			}
			
			return $return;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}