//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_MemberHook extends _HOOK_CLASS_
{
	public function shopPoints()
	{
		try
		{
			try
			{
				$memberPoints = \IPS\membersshop\Points::load( $this->member_id, 'member_id' )->points;
			}
			catch( \Exception $ex )
			{
				$memberPoints = 0;
			}
			return $memberPoints;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function addPoints( $points=NULL, $message=NULL )
	{
		try
		{
			try
			{
				$memberPoints = \IPS\membersshop\Points::load( $this->member_id, 'member_id' );
			}
			catch( \Exception $ex )
			{
				$memberPoints = new \IPS\membersshop\Points;
				$memberPoints->member_id = $this->member_id;
			}
			
			$memberPoints->points = $memberPoints->points + $points;
			$memberPoints->save();
			
			$log = new \IPS\membersshop\Logs;
			$log->time_date = time();
			$log->member_id = $this->member_id;
			$log->type = 1;
			$log->note = $message;
			$log->amount = $points;
			$log->points = $this->shopPoints();
			$log->save();
			
			return;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function removePoints( $points=NULL, $message=NULL )
	{
		try
		{
			$memberPoints = \IPS\membersshop\Points::load( $this->member_id, 'member_id' );
			$memberPoints->points = $memberPoints->points - $points;
			$memberPoints->save();
			
			$log = new \IPS\membersshop\Logs;
			$log->time_date = time();
			$log->member_id = $this->member_id;
			$log->type = 2;
			$log->note = $message;
			$log->amount = $points;
			$log->points = $this->shopPoints();
			$log->save();
			
			return;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function editPoints( $points=NULL, $message=NULL )
	{
		try
		{
			try
			{
				$memberPoints = \IPS\membersshop\Points::load( $this->member_id, 'member_id' );
				$memberPoints->points = $points;
				$memberPoints->save();
			}
			catch( \Exception $ex )
			{
				$memberPoints = new \IPS\membersshop\Points;
				$memberPoints->member_id = $this->member_id;
				$memberPoints->points = $points;
				$memberPoints->save();
			}
			
			$log = new \IPS\membersshop\Logs;
			$log->time_date = time();
			$log->member_id = $this->member_id;
			$log->type = 3;
			$log->note = $message;
			$log->amount = $points;
			$log->points = $this->shopPoints();
			$log->save();
			
			return;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function resetPoints( $points=NULL, $message=NULL )
	{
		try
		{
			try
			{
				$memberPoints = \IPS\membersshop\Points::load( $this->member_id, 'member_id' );
				$memberPoints->points = 0;
				$memberPoints->save();
			}
			catch( \Exception $ex )
			{
				$memberPoints = new \IPS\membersshop\Points;
				$memberPoints->member_id = $this->member_id;
				$memberPoints->points = 0;
				$memberPoints->save();
			}
			
			$log = new \IPS\membersshop\Logs;
			$log->time_date = time();
			$log->member_id = $this->member_id;
			$log->type = 4;
			$log->note = $message;
			$log->amount = $points;
			$log->points = $this->shopPoints();
			$log->save();
			
			return;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}