//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_TopicHook extends _HOOK_CLASS_
{
	protected function processAfterCreate( $comment, $values )
	{
		try
		{
			try
			{
			    \call_user_func_array( 'parent::processAfterCreate', \func_get_args() );
		        
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					if ( $this->container()->club() )
					{
						if ( \IPS\Settings::i()->ms_club_points_tstarter )
						{
							$points = \IPS\Settings::i()->ms_club_points_tstarter;
						}
						else
						{
							$points = NULL;
						}
					}
					else
					{
						try
						{
							$points = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_per_topic;
						}
						catch ( \OutOfRangeException $e )
						{
							$points = 0;
						}
					}
					
					if( $points AND \IPS\Settings::i()->ms_group_gain_forums == 'all' AND \IPS\Member::loggedIn()->member_id or $points AND \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_group_gain_forums ) ) AND \IPS\Member::loggedIn()->member_id )
					{
						$topicAuthor = $comment->author();
						$pointsName = \IPS\Settings::i()->ms_points_name;
						
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_created'), $this->url(), $this->title );
						$topicAuthor->addPoints( $points, $logsACP );
						
						$reward = new \IPS\membersshop\Rewards;
						$reward->item_id = -2;
						$reward->member_id = $topicAuthor->member_id;
						$reward->time_date = time();
						$reward->reward = $points;
						$reward->save();
					}
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	public function processCommentForm( $values )
	{       
		try
		{
			try
			{
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					if ( $this->container()->club() )
					{
						if ( \IPS\Settings::i()->ms_club_points_treply )
						{
							$points = \IPS\Settings::i()->ms_club_points_treply;
						}
						else
						{
							$points = NULL;
						}
					}
					else
					{
						try
						{
							$points = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_per_reply;
						}
						catch ( \OutOfRangeException $e )
						{
							$points = 0;
						}
					}
					
					if( $points AND \IPS\Settings::i()->ms_group_gain_forums == 'all' AND \IPS\Member::loggedIn()->member_id or $points AND \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_group_gain_forums ) ) AND \IPS\Member::loggedIn()->member_id )
					{
						$postAuthor = \IPS\Member::loggedIn();
						$pointsName = \IPS\Settings::i()->ms_points_name;
						
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_reply'), $this->url(), $this->title );
						$postAuthor->addPoints( $points, $logsACP );
						
						$reward = new \IPS\membersshop\Rewards;
						$reward->item_id = -3;
						$reward->member_id = $postAuthor->member_id;
						$reward->time_date = time();
						$reward->reward = $points;
						$reward->save();
						
						try
						{
							$pointsToTS = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_to_ts_pr;
						}
						catch ( \OutOfRangeException $e )
						{
							$pointsToTS = 0;
						}
						
						if( $pointsToTS > 0 )
						{
							$topicAuthor = $this->author(); 
							if ( $postAuthor !== $topicAuthor )
							{
								$pointsName = \IPS\Settings::i()->ms_points_name;
								$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_reply_starter'), $this->url(), $this->title );
								$topicAuthor->addPoints( $points, $logsACP );
								
								$reward = new \IPS\membersshop\Rewards;
								$reward->item_id = -4;
								$reward->member_id = $topicAuthor->member_id;
								$reward->time_date = time();
								$reward->reward = $pointsToTS;
								$reward->save();						
							}					
						}            
					}  
		        }
			    return \call_user_func_array( 'parent::processCommentForm', \func_get_args() );        
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function delete()
	{
		try
		{
			try
			{
				\call_user_func_array( 'parent::delete', \func_get_args() );
				
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					if ( \IPS\Settings::i()->ms_remove_on_delete )
					{
						try
						{
							$points = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_per_topic;
						}
						catch ( \OutOfRangeException $e )
						{
							$points = 0;
						}
						
						$topicAuthor = $this->author();
						$pointsName = \IPS\Settings::i()->ms_points_name;
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_deleted'), $this->title );
						$topicAuthor->removePoints( $points, $logsACP );
					}
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}