//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_UploadHook extends _HOOK_CLASS_
{
	protected function processAfterCreate( $comment, $values )
	{
		try
		{
			try
			{
			    \call_user_func_array( 'parent::processAfterCreate', \func_get_args() );
		        
				if( !\IPS\Settings::i()->ms_disable_downloads_hooks )
				{
					if ( $this->container()->club() )
					{
						if ( \IPS\Settings::i()->ms_club_points_duploader )
						{
							$points = \IPS\Settings::i()->ms_club_points_duploader;
						}
						else
						{
							$points = 0;
						}
					}
					else
					{
						try
						{
							$points = \IPS\membersshop\Downloads\Points::load( $this->container()->_id, 'cat_id' )->points_for_upload;
						}
						catch ( \OutOfRangeException $e )
						{
							$points = 0;
						}
					}
					
					if( $points AND \IPS\Settings::i()->ms_group_gain_forums == 'all' AND \IPS\Member::loggedIn()->member_id or $points AND \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_group_gain_forums ) ) AND \IPS\Member::loggedIn()->member_id )
					{
						$uploadAuthor = $this->author(); 
						$pointsName = \IPS\Settings::i()->ms_points_name;
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_file_upload'), $this->url(), $this->name );
						$uploadAuthor->addPoints( $points, $logsACP );
						
						$reward = new \IPS\membersshop\Rewards;
						$reward->item_id = -6;
						$reward->member_id = $uploadAuthor->member_id;
						$reward->time_date = time();
						$reward->reward = $points;
						$reward->save();
					}
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public static function formElements( $item=NULL, \IPS\Node\Model $container=NULL )
	{
		try
		{
			try
			{
				$pointsName = \IPS\Settings::i()->ms_points_name;
				$return = parent::formElements( $item, $container );
				
				if( !\IPS\Settings::i()->ms_disable_downloads_hooks )
				{
					try
					{
						$filePoints = \IPS\membersshop\Downloads\Files::load( $item->id, 'file_id' )->points;
					}
					catch ( \Exception $e )
					{
						$filePoints = NULL;
					}
					
					if ( \IPS\Application::appIsEnabled( 'nexus' ) and \IPS\Settings::i()->idm_nexus_on and \IPS\Member::loggedIn()->group['idm_add_paid'] )
					{
						$options = array(
							'free'		=> 'file_free',
							'paid'		=> 'file_paid'
						);
						if ( \IPS\Settings::i()->ms_downloads_paid_groups == 'all' or \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_downloads_paid_groups ) ) )
						{
							$options['points'] = $pointsName;
						}
						if ( \IPS\Member::loggedIn()->isAdmin() AND \count( \IPS\nexus\Package::roots() ) > 0 )
						{
							$options['nexus'] = 'file_associate_nexus';
						}
						$return['file_cost_type'] = new \IPS\Helpers\Form\Radio( 'file_cost_type', $item ? ( $filePoints ? 'points' : ( $item->cost ? 'paid' : ( $item->nexus ? 'nexus' : 'free' ) ) ) : 'free', TRUE, array(
							'options'	=> $options,
							'toggles'	=> array(
								'paid'		=> array( 'file_cost', 'file_renewals' ),
								'nexus'		=> array( 'file_nexus' ),
								'points'    => array( 'ms_file_points' )
							)
						) );
					}
					
					if ( \IPS\Settings::i()->ms_downloads_paid_groups == 'all' or \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_downloads_paid_groups ) ) )
					{
						if ( $item )
						{
							if ( !$filePoints ){ $value = -1; }
							else { $value = $filePoints; }	
							$return['ms_file_points'] = new \IPS\Helpers\Form\Number( 'ms_file_points', $item ? $value : -1, TRUE, array( 'unlimited' => -1, 'unlimitedLang' => 'Free' ), NULL, NULL, $pointsName, 'ms_file_points' );
						}
						else
						{
							$return['ms_file_points'] = new \IPS\Helpers\Form\Number( 'ms_file_points', -1, TRUE, array( 'unlimited' => -1, 'unlimitedLang' => 'Free' ), NULL, NULL, $pointsName, 'ms_file_points' );
						}
					}
				}
				
				return $return;
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function processForm( $values )
	{
		try
		{
			try
			{
				$parent = parent::processForm( $values );
				
				if( !\IPS\Settings::i()->ms_disable_downloads_hooks )
				{
					try
					{
						$filePoints = \IPS\membersshop\Downloads\Files::load( $this->id, 'file_id' );
					}
					catch( \Exception $e )
					{
						$filePoints = NULL;
					}
					
					if ( \IPS\Settings::i()->ms_downloads_paid_groups == 'all' or \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_downloads_paid_groups ) ) )
					{
						if ( \IPS\Application::appIsEnabled( 'nexus' ) and \IPS\Settings::i()->idm_nexus_on and \IPS\Member::loggedIn()->group['idm_add_paid'] )
						{
							switch ( $values['file_cost_type'] )
							{
								case 'free':
									$this->cost = NULL;
									$this->renewal_term = 0;
									$this->renewal_units = NULL;
									$this->renewal_price = NULL;
									$this->nexus = NULL;
									if( $filePoints )
									{
										$filePoints->delete();
									}
									break;
									
								case 'paid':
									$this->cost = json_encode( $values['file_cost'] );
									if ( $values['file_renewals'] and $values['file_renewal_term'] )
									{						
										$term = $values['file_renewal_term']->getTerm();
										$this->renewal_term = $term['term'];
										$this->renewal_units = $term['unit'];
										$this->renewal_price = json_encode( $values['file_renewal_term']->cost );
										if( $filePoints )
										{
											$filePoints->delete();
										}
									}
									else
									{
										$this->renewal_term = 0;
										$this->renewal_units = NULL;
										$this->renewal_price = NULL;
										if( $filePoints )
										{
											$filePoints->delete();
										}
									}
									$this->nexus = NULL;
									break;
									
								case 'nexus':
									$this->cost = NULL;
									$this->renewal_term = 0;
									$this->renewal_units = NULL;
									$this->renewal_price = NULL;
									$this->nexus = implode( ',', array_keys( $values['file_nexus'] ) );
									if( $filePoints )
									{
										$filePoints->delete();
									}
									break;
								
								case 'points':
									if( $filePoints )
									{
										$filePoints->points = $values['ms_file_points'];
										$filePoints->file_cat_id = $this->cat;
										$filePoints->save();
									}
									else
									{
										$filePoints = new \IPS\membersshop\Downloads\Files;
										$filePoints->file_id = $this->id;
										$filePoints->points = $values['ms_file_points'];
										$filePoints->file_cat_id = $this->cat;
										$filePoints->save();
									}
									$this->cost = NULL;
									$this->renewal_term = 0;
									$this->renewal_units = NULL;
									$this->renewal_price = NULL;
									$this->nexus = NULL;
									break;
							}
							$this->save();
						}
						
						if ( !\IPS\Application::appIsEnabled( 'nexus' ) )
						{
							if ( $values['ms_file_points'] != -1 )
							{
								if( $filePoints )
								{
									$filePoints->points = $values['ms_file_points'];
									$filePoints->save();
								}
								else
								{
									$filePoints = new \IPS\membersshop\Downloads\Files;
									$filePoints->file_id = $this->id;
									$filePoints->points = $values['ms_file_points'];
									$filePoints->file_cat_id = $this->cat_id;
									$filePoints->save();
								}
							}
							if ( $values['ms_file_points'] == -1 )
							{
								if( $filePoints )
								{
									$filePoints->delete();
								}
							}
						}
					}
				}
				return $parent;
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
