//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_WarningProcess extends _HOOK_CLASS_
{
	protected function processAfterCreate( $comment, $values )
	{
		try
		{
			try
			{
				parent::processAfterCreate( $comment, $values );
				
				try
				{
					$points = \IPS\membersshop\Warnings::load( $values['warn_reason'], 'reason_id' )->points;
				}
				catch( \Exception $e )
				{
					$points = 0;
				}
				
				if ( $points > 0 )
				{
					$member = \IPS\Member::load( $this->member );
					$pointsName = \IPS\Settings::i()->ms_points_name;
					$reasonTitle = \IPS\Member::loggedIn()->language()->get('core_warn_reason_'.$values['warn_reason'].'');
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_warning_received'), $reasonTitle );
					$member->removePoints( $points, $logsACP );
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
