<?php


namespace IPS\membersshop\modules\admin\points;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * clubs
 */
class _clubs extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_clubs' );
		
		\IPS\Output::i()->sidebar['actions']['misc'] = array(
			'icon'		=> 'superpowers',
			'title'		=> 'ms_misc',
			'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=misc' ),
			'data'		=> array( )
		);	
		
		if ( \IPS\Application::appIsEnabled( 'calendar') AND !\IPS\Settings::i()->ms_disable_calendar_hooks )
		{
			\IPS\Output::i()->sidebar['actions']['calendar'] = array(
				'icon'		=> 'calendar',
				'title'		=> 'ms_calendar',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=calendars' ),
				'data'		=> array( )
			);	
		}
		
		if ( \IPS\Application::appIsEnabled( 'gallery') AND !\IPS\Settings::i()->ms_disable_gallery_hooks )
		{
			\IPS\Output::i()->sidebar['actions']['gallery'] = array(
				'icon'		=> 'image',
				'title'		=> 'ms_gallery',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=gallerys' ),
				'data'		=> array( )
			);	
		}
		
		if ( \IPS\Application::appIsEnabled( 'downloads') AND !\IPS\Settings::i()->ms_disable_downloads_hooks )
		{
			\IPS\Output::i()->sidebar['actions']['add'] = array(
				'icon'		=> 'download',
				'title'		=> 'ms_downloads',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=downloads' ),
				'data'		=> array( )
			);	
		}
		
		if( \IPS\Application::appIsEnabled( 'forums') AND !\IPS\Settings::i()->ms_disable_forum_hooks )
		{	
			\IPS\Output::i()->sidebar['actions']['forums'] = array(
				'icon'		=> 'comment-o',
				'title'		=> 'ms_forums',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=forums' ),
				'data'		=> array( )
			);
		}
		
		if ( \IPS\Settings::i()->clubs AND !\IPS\Settings::i()->ms_disable_clubs_hooks )
		{
			$form = new \IPS\Helpers\Form;
			$form->addTab('ms_clubs');
			$form->addHeader('ms_clubs');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_clubs_enable', \IPS\Settings::i()->ms_clubs_enable, FALSE, array('togglesOn' => array( 'ms_clubs_join', 'ms_clubs_leave' ) ) ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_clubs_join', \IPS\Settings::i()->ms_clubs_join, FALSE, array( ), NULL, NULL, NULL, 'ms_clubs_join' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_clubs_leave', \IPS\Settings::i()->ms_clubs_leave, FALSE, array( ), NULL, NULL, NULL, 'ms_clubs_leave' ) );
			$form->addHeader('ms_club_header');
			$form->addMessage('ms_club_message');
			$form->addHeader('ms_forums');
			$form->add( new \IPS\Helpers\Form\Number( 'ms_club_points_tstarter', \IPS\Settings::i()->ms_club_points_tstarter, FALSE, array( ), NULL, NULL, NULL, 'ms_club_points_tstarter' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_club_points_treply', \IPS\Settings::i()->ms_club_points_treply, FALSE, array( ), NULL, NULL, NULL, 'ms_club_points_treply' ) );
			if ( \IPS\Application::appIsEnabled( 'downloads' ) )
			{
				$form->addHeader('ms_downloads');
				$form->add( new \IPS\Helpers\Form\Number( 'ms_club_points_duploader', \IPS\Settings::i()->ms_club_points_duploader, FALSE, array( ), NULL, NULL, NULL, 'ms_club_points_duploader' ) );
				/*$form->add( new \IPS\Helpers\Form\Number( 'ms_club_points_ddownloader', \IPS\Settings::i()->ms_club_points_ddownloader, FALSE, array( ), NULL, NULL, NULL, 'ms_club_points_ddownloader' ) );*/
			}
			
			$extensions = \IPS\Application::allExtensions( 'membersshop', 'Points', FALSE );
			foreach ( $extensions as $k => $class )
			{
				if ( method_exists( $class, 'clubPoints' ) )
				{	
					$class->clubPoints( $form );
				}
			}
			
			if ( $values = $form->values() )
			{
				$form->saveAsSettings();
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=clubs' ), 'saved' );
				return TRUE;
			}
			
			\IPS\Output::i()->output = $form;
		}
		else
		{
			\IPS\Output::i()->output = '<div class="ipsPad ipsBox">You must have clubs enabled and the disable clubs settings switched off to use this feature</div>';
		}
	}
	
	// Create new methods with the same name as the 'do' parameter which should execute it
}