<?php


namespace IPS\membersshop\modules\admin\points;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * misc
 */
class _misc extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$form = new \IPS\Helpers\Form;
		$form->addTab('ms_disable_hooks_tab');
		if ( \IPS\Application::appIsEnabled( 'calendar' ) )
		{
			$form->addHeader('ms_disable_calendar_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_calendar_hooks', \IPS\Settings::i()->ms_disable_calendar_hooks, FALSE, array( ), NULL, NULL, NULL, 'ms_disable_calendar_hooks' ) );
		}
		if ( \IPS\Settings::i()->clubs )
		{
			$form->addHeader('ms_disable_clubs_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_clubs_hooks', \IPS\Settings::i()->ms_disable_clubs_hooks, FALSE, array( ), NULL, NULL, NULL, 'ms_disable_clubs_hooks' ) );
		}
		if ( \IPS\Application::appIsEnabled( 'downloads' ) )
		{
			$form->addHeader('ms_disable_downloads_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_downloads_hooks', \IPS\Settings::i()->ms_disable_downloads_hooks, FALSE, array( ), NULL, NULL, NULL, 'ms_disable_downloads_hooks' ) );
		}
		if ( \IPS\Application::appIsEnabled( 'forums' ) )
		{
			$form->addHeader('ms_disable_forum_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_forum_hooks', \IPS\Settings::i()->ms_disable_forum_hooks, FALSE, array( ), NULL, NULL, NULL, 'ms_disable_forum_hooks' ) );
		}
		if ( \IPS\Application::appIsEnabled( 'gallery' ) )
		{
			$form->addHeader('ms_disable_gallery_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_gallery_hooks', \IPS\Settings::i()->ms_disable_gallery_hooks, FALSE, array( ), NULL, NULL, NULL, 'ms_disable_gallery_hooks' ) );
		}
		if ( \IPS\Application::appIsEnabled( 'nexus' ) )
		{
			$form->addHeader('ms_disable_nexus_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_nexus_hooks', \IPS\Settings::i()->ms_disable_nexus_hooks, FALSE, array( ), NULL, NULL, NULL, 'ms_disable_nexus_hooks' ) );
		}
		
		$form->addTab('ms_tab1');
		$form->addHeader('ms_registration_referrer');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_enable_referrer_points', \IPS\Settings::i()->ms_enable_referrer_points, FALSE, array( 'togglesOn' => array( 'ms_referrer_points' ) ), NULL, NULL, NULL, 'ms_enable_referrer_points' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_referrer_points', \IPS\Settings::i()->ms_referrer_points, FALSE, array( ), NULL, NULL, NULL, 'ms_referrer_points' ) );
		
		$form->addHeader('ms_statuses');
		$form->add( new \IPS\Helpers\Form\Number( 'ms_status_points_create', \IPS\Settings::i()->ms_status_points_create, FALSE, array( ), NULL, NULL, NULL, 'ms_status_points_create' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_status_points_reply', \IPS\Settings::i()->ms_status_points_reply, FALSE, array( ), NULL, NULL, NULL, 'ms_status_points_reply' ) );
		
		if ( \IPS\Application::appIsEnabled( 'nexus' ) AND !\IPS\Settings::i()->ms_disable_nexus_hooks )
		{
			$form->addHeader('ms_nexus');
		    $form->add( new \IPS\Helpers\Form\Number( 'ms_nexus_points_reivew', \IPS\Settings::i()->ms_nexus_points_reivew, FALSE, array( ), NULL, NULL, NULL, 'ms_nexus_points_reivew' ) );
		}
		if ( \IPS\Application::appIsEnabled( 'mediauploader' ) )
		{
			$form->addTab('ms_mediauploader');
			$form->addHeader('ms_mediauploader');
			$form->add( new \IPS\Helpers\Form\Number( 'ms_mediauploader_imageupload', \IPS\Settings::i()->ms_mediauploader_imageupload, FALSE, array( ), NULL, NULL, NULL, 'ms_mediauploader_imageupload' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_mediauploader_audioupload', \IPS\Settings::i()->ms_mediauploader_audioupload, FALSE, array( ), NULL, NULL, NULL, 'ms_mediauploader_audioupload' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_mediauploader_videoupload', \IPS\Settings::i()->ms_mediauploader_videoupload, FALSE, array( ), NULL, NULL, NULL, 'ms_mediauploader_videoupload' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_mediauploader_docupload', \IPS\Settings::i()->ms_mediauploader_docupload, FALSE, array( ), NULL, NULL, NULL, 'ms_mediauploader_docupload' ) );
		}
		
		$extensions = \IPS\Application::allExtensions( 'membersshop', 'Points', FALSE );
		foreach ( $extensions as $k => $class )
		{
			if ( method_exists( $class, 'miscPoints' ) )
			{	
				$class->miscPoints( $form );
			}
		}
		
		/*
		if ( \IPS\Application::appIsEnabled( 'stickynotes' ) )
		{
			$form->addHeader('ms_stickynotes');
			$form->add( new \IPS\Helpers\Form\Number( 'ms_stickynotes_send_note', \IPS\Settings::i()->ms_stickynotes_send_note, FALSE, array( ), NULL, NULL, NULL, 'ms_stickynotes_send_note' ) );
		}
		*/
		
		if ( $values = $form->values() )
        {
	        $form->saveAsSettings();
	        \IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=misc' ), 'saved' );
	        return TRUE;
        }
		
		if ( \IPS\Settings::i()->clubs )
		{
			\IPS\Output::i()->sidebar['actions']['clubs'] = array(
				'icon'		=> 'users',
				'title'		=> 'ms_clubs',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=clubs' ),
				'data'		=> array( )
			);	
		}
		
		if ( \IPS\Application::appIsEnabled( 'calendar') AND !\IPS\Settings::i()->ms_disable_calendar_hooks )
		{
			\IPS\Output::i()->sidebar['actions']['calendar'] = array(
				'icon'		=> 'calendar',
				'title'		=> 'ms_calendar',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=calendars' ),
				'data'		=> array( )
			);	
		}
		
		if ( \IPS\Application::appIsEnabled( 'gallery') AND !\IPS\Settings::i()->ms_disable_gallery_hooks )
		{
			\IPS\Output::i()->sidebar['actions']['gallery'] = array(
				'icon'		=> 'image',
				'title'		=> 'ms_gallery',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=gallerys' ),
				'data'		=> array( )
			);	
		}
		
		if ( \IPS\Application::appIsEnabled( 'downloads') AND !\IPS\Settings::i()->ms_disable_downloads_hooks )
		{
			\IPS\Output::i()->sidebar['actions']['add'] = array(
				'icon'		=> 'download',
				'title'		=> 'ms_downloads',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=downloads' ),
				'data'		=> array( )
			);	
		}
		
		if( \IPS\Application::appIsEnabled( 'forums') AND !\IPS\Settings::i()->ms_disable_forum_hooks )
		{
			\IPS\Output::i()->sidebar['actions']['forums'] = array(
				'icon'		=> 'comment-o',
				'title'		=> 'ms_forums',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=forums' ),
				'data'		=> array( )
			);
		}
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_miscellaneous' );
		\IPS\Output::i()->output = $form;
	}
	
	// Create new methods with the same name as the 'do' parameter which should execute it
}