<?php


namespace IPS\membersshop\modules\admin\shop;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * information
 */
class _information extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$supportedApps = array();
		
		$supportedApps['forums'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'forums') )
		{
			$supportedApps['forums'] = TRUE;
		}
		
		$supportedApps['downloads'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'downloads') )
		{
			$supportedApps['downloads'] = TRUE;
		}
		
		$supportedApps['gallery'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'gallery') )
		{
			$supportedApps['gallery'] = TRUE;
		}
		
		$supportedApps['calendar'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'calendar') )
		{
			$supportedApps['calendar'] = TRUE;
		}
		
		$supportedApps['nexus'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'nexus') )
		{
			$supportedApps['nexus'] = TRUE;
		}
		
		$supportedApps['sportsbettingapp'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'sportsbettingapp') )
		{
			$supportedApps['sportsbettingapp'] = TRUE;
		}
		
		$supportedApps['lottery'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'lottery') )
		{
			$supportedApps['lottery'] = TRUE;
		}
		
		$supportedApps['mscodesnvouchers'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'mscodesnvouchers') )
		{
			$supportedApps['mscodesnvouchers'] = TRUE;
		}
		
		$supportedApps['msclubaddon'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'msclubaddon') )
		{
			$supportedApps['msclubaddon'] = TRUE;
		}
		
		$supportedApps['msevents'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'msevents') )
		{
			$supportedApps['msevents'] = TRUE;
		}
		
		$supportedApps['stickynotes'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'stickynotes') )
		{
			$supportedApps['stickynotes'] = TRUE;
		}
		
		$supportedApps['mediauploader'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'mediauploader') )
		{
			$supportedApps['mediauploader'] = TRUE;
		}
		
		$supportedApps['memberssocialinfo'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'memberssocialinfo') )
		{
			$supportedApps['memberssocialinfo'] = TRUE;
		}
		
		$supportedApps['rules'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'rules') )
		{
			$supportedApps['rules'] = TRUE;
		}
		
		$supportedApps['trophies'] = FALSE;
		if ( \IPS\Application::appIsEnabled( 'trophies') )
		{
			$supportedApps['trophies'] = TRUE;
		}
		
		try
		{
			$sql = \IPS\Db::i()->select( 'plugin_id', 'core_plugins', array( 'plugin_name=? AND plugin_enabled=1', 'Profile Video' ) )->first();
			$profileVideo = \IPS\Plugin::load( $sql );
			$supportedApps['profilevideo'] = TRUE;
		}
		catch( \Exception $e )
		{
		    $supportedApps['profilevideo'] = FALSE;
		}
		
		try
		{
			$sql2 = \IPS\Db::i()->select( 'plugin_id', 'core_plugins', array( 'plugin_name=? AND plugin_enabled=1', 'Profile Backgrounds' ) )->first();
			$profileBackground = \IPS\Plugin::load( $sql2 );
			$supportedApps['profilebackgrounds'] = TRUE;
		}
		catch( \Exception $e )
		{
		    $supportedApps['profilebackgrounds'] = FALSE;
		}
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('ms_information');
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'shop' )->information( $supportedApps );
	}
}