<?php


namespace IPS\membersshop\modules\admin\shop;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * items
 */
class _items extends \IPS\Node\Controller
{
	/**
     * Node Class
     */
    protected $nodeClass = '\IPS\membersshop\Categories';
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}
	
	protected function manage()
	{
		parent::manage();
	}
	
	protected function doCustom()
	{
		$id  = \intval( \IPS\Request::i()->id );
		$item = \IPS\membersshop\Items::load( $id );
		$form = new \IPS\Helpers\Form( 'membersshop', 'ms_send' );
		$form->add(new \IPS\Helpers\Form\Member('ms_give_to', NULL, TRUE, array( ) ));
		$form->add( new \IPS\Helpers\Form\Text( 'ms_dName', $item->name, TRUE, array( 'placeholder' => '' ), NULL, NULL, NULL, 'ms_dName' ) );
		$form->add( new \IPS\Helpers\Form\Editor( 'ms_dDescription', $item->desc, TRUE, array( 'app' => 'membersshop', 'key' => 'membersshop', 'autoSaveKey' => 'membersshop_'.$item->id.'', 'attachIds' => NULL, 'minimize' => 'Click to enter a description', 'minimizeIcon' => 'fa fa-chevron-down' ), NULL, NULL, NULL, 'ms_dDescription' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_dTakePrice', NULL, TRUE, array( 'togglesOff' => array( 'ms_dPrice' ) ), NULL, NULL, NULL, 'ms_dTakePrice' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_dPrice', $item->price, TRUE, array( ), NULL, NULL, NULL, 'ms_dPrice' ) );
		if ( $item->item_id == 1 or $item->item_id == 2 or $item->item_id == 3 or $item->item_id == 5 or $item->item_id == 16 or $item->item_id == 17)
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_dMinRand', $item->minRand, TRUE, array( ), NULL, NULL, NULL, 'ms_dMinRand' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_dMaxRand', $item->maxRand, TRUE, array( ), NULL, NULL, NULL, 'ms_dMaxRand' ) );
		}
		
		if ( $item->item_id == 1 or $item->item_id == 2 or $item->item_id == 5 or $item->item_id == 30 )
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_win_percent', $item->extra_field, TRUE, array( 'min' => 1, 'max' => 99, 'unlimited' => -1, 'unlimitedLang' => \IPS\Member::loggedIn()->language()->addToStack( 'ms_everyones_a_winner' ) ), NULL, NULL, '%', 'ms_win_percent' ) );
		}
		
		if ( $item->item_id == 10 )
		{
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_enable_increase', $item->extra_field, TRUE, array( 'togglesOn' => array( 'ms_increase_amount') ), NULL, NULL, NULL, 'ms_enable_increase' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_increase_amount', $item->maxRand, FALSE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_points' ), 'ms_increase_amount' ) );
		}
		
		if ( $item->item_id == 11 )
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_pin_time_days', $item->extra_field, TRUE, array( 'max' => 31, 'min' => 1 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_pin_time_days' ) );
		}
		
		if ( $item->item_id == 12 )
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_feature_time_days', $item->extra_field, TRUE, array( 'max' => 31, 'min' => 1 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_feature_time_days' ) );
		}
		
		if ( $item->item_id == 13 or $item->item_id == 14 or $item->item_id == 15 )
		{
			$form->add( new \IPS\Helpers\Form\Select( 'ms_reward_user_group', $item->minRand, TRUE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ) ) );
	        $form->add( new \IPS\Helpers\Form\Select( 'ms_select_reward_dmy', $item->maxRand, TRUE, array( 
			'options' => array(
				0  => 'Days',
				1  => 'Months',
				2  => 'Years'),
			 'toggles' => array(
				0 => array( 'ms_upgrade_time_days' ),
				1 => array( 'ms_upgrade_time_months' ),
				2 => array( 'ms_upgrade_time_years' ),
			) ), NULL, NULL, NULL, 'ms_select_reward_dmy'));	
    		$form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_days', $item->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_upgrade_time_days' ) );
		    $form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_months', $item->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_months' ), 'ms_upgrade_time_months' ) );
		    $form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_years', $item->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_years' ), 'ms_upgrade_time_years' ) );
		}
		
		if ( $item->item_id == 21 )
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_multipleguess', $item->minRand, TRUE, array( ), NULL, NULL, NULL, 'ms_multipleguess' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_guessnumbermaxamount', $item->maxRand, TRUE, array( ), NULL, NULL, NULL, 'ms_guessnumbermaxamount' ) );
		}
			
		if ( $item->item_id == 26 )
		{
			$form->add( new \IPS\Helpers\Form\Text( 'ms_custom_code', NULL, TRUE, array( 'placeholder' => 'HDFJ-56D8-T0F2-29JD' ), NULL, NULL, NULL, 'ms_custom_code' ) );
		}
		
		if ( $item->item_id == 27 )
		{
			$form->add( new \IPS\Helpers\Form\Node( 'ms_pick_trophy', $item ? $item->minRand : 0, TRUE, array( 'class' => 'IPS\trophies\Trophy', 'subnodes' => TRUE ) ) );
		}
			
		if ( $item->item_id == 28 )
		{
			$form->add( new \IPS\Helpers\Form\Node( 'ms_pick_medal', $item ? $item->minRand : 0, TRUE, array( 'class' => 'IPS\trophies\Medals', 'subnodes' => TRUE ) ) );
		}
		
		if ( $item->item_id == 30 )
		{
			$sql = \IPS\Db::i()->select( '*', 'membersshop_items', array( 'id IS NOT NULL AND id!=?', $this->id ) );
			foreach( $sql as $k => $v )
			{
				$f[ $v[ 'id' ] ] = $v[ 'name' ];
			}
			$form->add( new \IPS\Helpers\Form\Select( 'ms_select_items', NULL, TRUE, array( 'multiple' => TRUE, 'options' => $f ), NULL, NULL, NULL, 'ms_select_items' ) );
		}
		
		$extensions = \IPS\Application::allExtensions( 'membersshop', 'Items', FALSE );
		foreach ( $extensions as $k => $class )
		{
			if ( method_exists( $class, 'editFormSettings' ) )
			{
				$class->editFormSettings( $form, $item );
			}
		}
		
        if ( $values = $form->values() )
        {
			$purchase = new \IPS\membersshop\Purchases;
			$purchase->item_id = $item->item_id;
			$purchase->member_id = $values['ms_give_to']->member_id;
			$purchase->name = $values['ms_dName'];
			$purchase->description = $values['ms_dDescription'];
			$purchase->price = $values['ms_dPrice'];
			$purchase->time_date = time();
			$purchase->icon = $item->icon;
			$purchase->redeemed = 0;
			
			/* Save random items values */
			if ( $item->item_id == 1 or $item->item_id == 2 or $item->item_id == 3 or $item->item_id == 5 or $item->item_id == 16 or $item->item_id == 17 )
			{
				$purchase->minRand = $values['ms_dMinRand'];
				$purchase->maxRand = $values['ms_dMaxRand'];
			}
			
			if ( $item->item_id == 1 or $item->item_id == 2 or $item->item_id == 5 or $item->item_id == 30 )
			{
				$purchase->extra_field = $values['ms_win_percent'];
			}
			
			/* Save rpsls increase values */
			if ( $item->item_id == 10 )
			{
				$purchase->extra_field = $values['ms_enable_increase'];
				$purchase->maxRand = $values['ms_increase_amount'];
			}
			
			/* Save pinned values */
			if ( $item->item_id == 11 )
			{
				$purchase->extra_field = $values['ms_pin_time_days'];
			}
			
			/* Save featured values */
			if ( $item->item_id == 12 )
			{
				$purchase->extra_field = $values['ms_feature_time_days'];
			}
			
			/* Save member upgrade values */
			if ( $item->item_id == 13 or $item->item_id == 14 or $item->item_id == 15 )
			{
				if ( $values['ms_select_reward_dmy'] == 0 )
				{
					$purchase->extra_field = $values['ms_upgrade_time_days'];
					$purchase->minRand = $values['ms_reward_user_group'];
					$purchase->maxRand = $values['ms_select_reward_dmy'];
				}
				elseif ( $values['ms_select_reward_dmy'] == 1 )
				{
					$purchase->extra_field = $values['ms_upgrade_time_months'];
					$purchase->minRand = $values['ms_reward_user_group'];
					$purchase->maxRand = $values['ms_select_reward_dmy'];
				}
				elseif ( $values['ms_select_reward_dmy'] == 2 ) 
				{
					$purchase->extra_field = $values['ms_upgrade_time_years'];
					$purchase->minRand = $values['ms_reward_user_group'];
					$purchase->maxRand = $values['ms_select_reward_dmy'];
				}
			}
			
			if ( $item->item_id == 21 )
			{
				$purchase->minRand = $values['ms_multipleguess'];
				$purchase->maxRand = $values['ms_guessnumbermaxamount'];
			}
			if ( $item->item_id == 26 )
			{
				$purchase->extra_field_text = $values['ms_custom_code'];
			}
			
			if ( $item->item_id == 27 )
			{
				$purchase->minRand = $values['ms_pick_trophy']->id;
			}
			
			if ( $item->item_id == 28 )
			{
				$purchase->minRand = $values['ms_pick_medal']->id;
			}
			
			if ( $item->item_id == 30 )
			{
				if( isset( $values['ms_select_items'] ) )
				{
					$values['ms_select_items'] = $values['ms_select_items'] === '*' ? '*' : implode( ',', $values['ms_select_items'] );
				}
				$purchase->extra_field_text = $values['ms_select_items'];
			}
			
			$purchase->save();
			
			$extensions = \IPS\Application::allExtensions( 'membersshop', 'Items', FALSE );
			foreach ( $extensions as $k => $class )
			{
				if ( method_exists( $class, 'processGenerateForm' ) )
				{	
					$class->processGenerateForm( $values, $purchase, $item );
				}
			}
			
			if ( !$values['ms_dTakePrice'] )
			{
				$points = $values['ms_dPrice'];
				
				$pointsName = \IPS\Settings::i()->ms_points_name;
				$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_item_purchase'), $item->name );
				$values['ms_give_to']->removePoints( $points, $logsACP );
			}
			
			$member = \IPS\Member::loggedIn();
			$received = new \IPS\membersshop\Received;
			$received->item_id = $item->item_id;
			$received->sender_id = $member->member_id;
			$received->receiver_id = $values['ms_give_to']->member_id;
			$received->time_date = time();
			$received->save();
			
			$items = \IPS\membersshop\Received::load( $received->id );
			
			$memberssssss = \IPS\Member::load( $values['ms_give_to']->member_id );
			$notification = new \IPS\Notification( \IPS\Application::load( 'membersshop' ), 'received_item', $items, array ( $items ) );
			$notification->recipients->attach( $memberssssss );
			$notification->send();
			
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=items' ), 'Sent' );
        }

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_custom_purchase' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function purchasers()
	{
		$id  = \intval( \IPS\Request::i()->id );
		$table = new \IPS\Helpers\Table\Db( 'membersshop_purchases', \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=items&do=purchasers&id=' . $id ) );
		$table->tableTemplate = array( \IPS\Theme::i()->getTemplate( 'stats' ), 'logTable' );
		$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate( 'stats' ), 'logRows' );
		$table->sortBy = 'time_date';
		$table->limit = 10;
        $table->where[] = array( 'item_id=?', $id );
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'stats' )->log( (string) $table );
	}
}