<?php


namespace IPS\membersshop\modules\admin\shop;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * settings
 */
class _settings extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$form = new \IPS\Helpers\Form;
		$form->addTab( 'ms_index_page_tab' );
		$form->addHeader('ms_main_header_text');
		$form->add( new \IPS\Helpers\Form\Editor( 'ms_header_text', \IPS\Settings::i()->ms_header_text, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => '' ) ) );
		$form->addHeader( 'ms_featured_items_header' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_featured_block',  \IPS\Settings::i()->ms_show_featured_block, TRUE, array( 'togglesOn' => array( 'ms_featured_block_amount' ) ), NULL, NULL, NULL, 'ms_show_featured_block' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_featured_block_amount',  \IPS\Settings::i()->ms_featured_block_amount, TRUE, array( ), NULL, NULL, NULL, 'ms_featured_block_amount' ) );
		$form->addHeader( 'ms_new_items_header' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_whats_new_block',  \IPS\Settings::i()->ms_show_whats_new_block, TRUE, array( 'togglesOn' => array( 'ms_whats_new_block_amount' ) ), NULL, NULL, NULL, 'ms_show_whats_new_block' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_whats_new_block_amount',  \IPS\Settings::i()->ms_whats_new_block_amount, TRUE, array( ), NULL, NULL, NULL, 'ms_whats_new_block_amount' ) );
		$form->addHeader( 'ms_popular_items_header' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_popular_block',  \IPS\Settings::i()->ms_show_popular_block, TRUE, array( 'togglesOn' => array( 'ms_popular_block_amount' ) ), NULL, NULL, NULL, 'ms_show_popular_block' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_popular_block_amount',  \IPS\Settings::i()->ms_popular_block_amount, TRUE, array( ), NULL, NULL, NULL, 'ms_popular_block_amount' ) );
		$form->addHeader( 'ms_low_stock_items_header' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_low_stock_block',  \IPS\Settings::i()->ms_show_low_stock_block, TRUE, array( 'togglesOn' => array( 'ms_low_stock_block_amount' ) ), NULL, NULL, NULL, 'ms_show_low_stock_block' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_low_stock_block_amount',  \IPS\Settings::i()->ms_low_stock_block_amount, TRUE, array( ), NULL, NULL, NULL, 'ms_low_stock_block_amount', 'ms_low_stock_block_when' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_low_stock_block_when',  \IPS\Settings::i()->ms_low_stock_block_when, TRUE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_instock'), 'ms_low_stock_block_when' ) );
		$form->addHeader( 'ms_most_expensive_items_header' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_most_expensive_block',  \IPS\Settings::i()->ms_show_most_expensive_block, TRUE, array( 'togglesOn' => array( 'ms_most_expensive_block_amount' ) ), NULL, NULL, NULL, 'ms_show_most_expensive_block' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_most_expensive_block_amount',  \IPS\Settings::i()->ms_most_expensive_block_amount, TRUE, array( ), NULL, NULL, NULL, 'ms_most_expensive_block_amount' ) );
		$form->addHeader( 'ms_random_items_header' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_random_block',  \IPS\Settings::i()->ms_show_random_block, TRUE, array( 'togglesOn' => array( 'ms_random_block_amount' ) ), NULL, NULL, NULL, 'ms_show_random_block' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_random_block_amount',  \IPS\Settings::i()->ms_random_block_amount, TRUE, array( ), NULL, NULL, NULL, 'ms_random_block_amount' ) );
		
		$form->addTab( 'ms_theme_settings_tab' );
		$form->addHeader('ms_theme_shop_header');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_shop_view_set', \IPS\Settings::i()->ms_shop_view_set, TRUE, array( 'options' => array( 0 => 'Table View', 1 => 'Grid View' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_shop_view_set') );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_shop_table_limit', \IPS\Settings::i()->ms_shop_table_limit, TRUE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_per_page'), 'ms_shop_table_limit' ) );
        $form->addHeader('ms_theme_myitems_header');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_myitems_view_set', \IPS\Settings::i()->ms_myitems_view_set, TRUE, array( 'options' => array( 0 => 'Table View', 1 => 'Grid View' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_myitems_view_set') );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_myitems_table_limit', \IPS\Settings::i()->ms_myitems_table_limit, TRUE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_per_page'), 'ms_myitems_table_limit' ) );
        $form->addHeader('ms_theme_logs_header');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_logs_view_set', \IPS\Settings::i()->ms_logs_view_set, TRUE, array( 'options' => array( 0 => 'Table View', 1 => 'Grid View' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_logs_view_set') );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_rewards_table_limit', \IPS\Settings::i()->ms_rewards_table_limit, TRUE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_per_page'), 'ms_rewards_table_limit' ) );
		$form->addHeader('ms_theme_stats_header');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_shop_stats_view', \IPS\Settings::i()->ms_shop_stats_view, TRUE, array( 'options' => array( 1 => 'Table View', 0 => 'Grid View' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_shop_stats_view') );
		$form->addHeader('ms_theme_more_header');
		$form->add( new \IPS\Helpers\Form\Radio( 'ms_grid_style', \IPS\Settings::i()->ms_grid_style, TRUE, array( 'options' => array( 0 => 'Small Boxes', 1 => 'Large Boxes' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_grid_style') );
		$form->addHeader('ms_show_stock_levels');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_stock_level', \IPS\Settings::i()->ms_show_stock_level, TRUE, array( ), NULL, NULL, NULL, 'ms_show_stock_level' ) );
        $form->addHeader('ms_theme_flash_message_header');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_flash_msg_pos', \IPS\Settings::i()->ms_flash_msg_pos, TRUE, array( 'options' => array( 'top' => 'Top', 'bottom' => 'Bottom' ) ) , NULL, NULL, NULL, 'ms_flash_msg_pos') );
		
		$form->addTab( 'ms_item_settings_tab' );
		$form->addHeader('ms_cost_to_send');
		$form->add( new \IPS\Helpers\Form\Number( 'ms_charge_to_send', \IPS\Settings::i()->ms_charge_to_send, FALSE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_percent_to_send'), 'ms_charge_to_send' ) );
        $form->addHeader('ms_cost_to_sellback');
		$form->add( new \IPS\Helpers\Form\Number( 'ms_charge_sell_back', \IPS\Settings::i()->ms_charge_sell_back, FALSE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_percent_to_sell_back'), 'ms_charge_sell_back' ) );
        
		/*
		$form->addHeader( 'ms_graph_colours' );
		$form->add( new \IPS\Helpers\Form\Color( 'ms_graph_background', \IPS\Settings::i()->ms_graph_background, TRUE, array( ), NULL, NULL, NULL, 'ms_graph_background' ) );
        $form->add( new \IPS\Helpers\Form\Color( 'ms_graph_text_colour', \IPS\Settings::i()->ms_graph_text_colour, TRUE, array( ), NULL, NULL, NULL, 'ms_graph_text_colour' ) );
        */
		
		/*
		$form->addTab( 'ms_custom_item_settings' );
		$form->addHeader( 'Notification' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_cp_notifi_members_enable', \IPS\Settings::i()->ms_cp_notifi_members_enable, FALSE, array('togglesOn' => array( 'ms_cp_notifi_members' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Member( 'ms_cp_notifi_members', \IPS\Settings::i()->ms_cp_notifi_members ? array_map( array( 'IPS\Member', 'load' ), explode( ",", \IPS\Settings::i()->ms_cp_notifi_members ) ) : NULL, TRUE, array( 'multiple' => 1 ), NULL, NULL, NULL, 'ms_cp_notifi_members' ) );
		$form->addHeader( 'Email' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_cp_email_members_enable', \IPS\Settings::i()->ms_cp_email_members_enable, FALSE, array('togglesOn' => array( 'ms_cp_email_members' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Member( 'ms_cp_email_members', \IPS\Settings::i()->ms_cp_email_members ? array_map( array( 'IPS\Member', 'load' ), explode( ",", \IPS\Settings::i()->ms_cp_email_members ) ) : NULL, TRUE, array( 'multiple' => 1 ), NULL, NULL, NULL, 'ms_cp_email_members' ) );
		*/
		
		$form->addTab( 'ms_custom_code_settings' );
		$form->addHeader( 'ms_pm_sender_header' );
		$form->add( new \IPS\Helpers\Form\Member( 'ms_cc_pm_members', \IPS\Settings::i()->ms_cc_pm_members ? array_map( array( 'IPS\Member', 'load' ), explode( ",", \IPS\Settings::i()->ms_cc_pm_members ) ) : NULL, TRUE, array( 'multiple' => 1 ), NULL, NULL, NULL, 'ms_cc_pm_members' ) );
		/*
		$form->addHeader( 'Email' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_cc_email_members_enable', \IPS\Settings::i()->ms_cc_email_members_enable, FALSE, array('togglesOn' => array( 'ms_cc_email_members' ) ) ) );
		*/
		
		$form->addTab( 'ms_item_misc' );
		$form->addHeader('ms_pinning_topics');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_pin_own_topics', \IPS\Settings::i()->ms_pin_own_topics, TRUE, array( ), NULL, NULL, NULL, 'ms_pin_own_topics' ) );
		
		if ( $values = $form->values() )
        {
			$form->saveAsSettings();
		    \IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings' ), 'saved' );
	        return TRUE;
        }
		
		/*
		\IPS\Output::i()->sidebar['actions']['supportedapps'] = array(
			'icon'		=> 'exclamation',
			'title'		=> 'ms_supported_apps',
			'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=information' ),
			'data'		=> array( 'ipsDialog' => TRUE, 'ipsDialog-title' => "Supported Apps & Plugins Installation Check", 'ipsDialog-size' => 'medium' )
		);
		*/
		
		if ( \IPS\Application::appIsEnabled( 'nexus') )
		{
			\IPS\Output::i()->sidebar['actions']['nexus'] = array(
				'primary'	=> true,
				'icon'		=> 'dollar',
				'title'		=> '__app_nexus',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings&do=pointPurchaseSettings' ),
				'data'		=> array( )
			);	
		}
		
		if( !isset( \IPS\Data\Store::i()->members_shop_cr ) )
		{
			\IPS\Output::i()->sidebar['actions']['fm_copyright_removal'] = array(
				'icon'		=> 'flash',
				'title'		=> 'Copyright Removal',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings&do=fm' ),
				'data'		=> array( )
			);
		}
			
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_settings' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function pointPurchaseSettings()
	{
		$pointsName = \IPS\Settings::i()->ms_points_name;
		$settings = json_decode( \IPS\Settings::i()->ms_points_sale_amount, true );
		$form = new \IPS\Helpers\Form;
		
		$form->addHeader( 'ms_currency_settings' );
		foreach( \IPS\nexus\Money::currencies() as $currency )
		{
			\IPS\Member::loggedIn()->language()->words[ 'shoppoints_exchange_rate_buy_'.$currency.'' ] = sprintf( \IPS\Member::loggedIn()->language()->get('membersshop_buying_points'), $pointsName, $currency );
			\IPS\Member::loggedIn()->language()->words[ 'shoppoints_exchange_rate_buy_'.$currency.'_desc' ] =  sprintf( \IPS\Member::loggedIn()->language()->get('membersshop_buying_points_desc'), $pointsName, $currency, $pointsName, $currency );
			$form->add( new \IPS\Helpers\Form\Number( 'shoppoints_exchange_rate_buy_'.$currency.'', isset( $settings[ $currency ] ) ? $settings[ $currency ] : 100, TRUE ) );
		}
		$form->addHeader( 'ms_min_max_amounts' );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_minimum_amount_to_buy', \IPS\Settings::i()->ms_minimum_amount_to_buy, TRUE, array( 'min' => 100 ), NULL, NULL, NULL, 'ms_minimum_amount_to_buy' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_maximum_amount_to_buy', \IPS\Settings::i()->ms_maximum_amount_to_buy, TRUE, array( 'min' => 100 ), NULL, NULL, NULL, 'ms_maximum_amount_to_buy' ) );
		$form->addHeader( 'ms_example_settings' );
		$form->add( new \IPS\Helpers\Form\Stack( 'ms_info_stack', explode( ',', \IPS\Settings::i()->ms_info_stack ), FALSE, array( 'stackFieldType' => 'Number', 'placeholder' => '' ), NULL, NULL, NULL, 'ms_info_stack' ) );
		
		if ( $values = $form->values() )
        {
			$getJson = array();
			foreach( \IPS\nexus\Money::currencies() as $currency )
			{
				$values['jsonencode'][$currency] = $values['shoppoints_exchange_rate_buy_'.$currency.''];
			}
			
			$saveSettings = json_encode( $values['jsonencode'] );
			\IPS\Settings::i()->changeValues( array( 'ms_points_sale_amount' => $saveSettings, 'ms_info_stack' => implode( ',', $values['ms_info_stack'] ), 'ms_minimum_amount_to_buy' => $values['ms_minimum_amount_to_buy'], 'ms_maximum_amount_to_buy' => $values['ms_maximum_amount_to_buy'] ) );
			
			foreach( \IPS\nexus\Money::currencies() as $currency )
			{
				unset( $values['shoppoints_exchange_rate_buy_'.$currency.''] );
			}	
			unset( $values['ms_info_stack'] );
			unset( $values['ms_minimum_amount_to_buy'] );
			unset( $values['ms_maximum_amount_to_buy'] );
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings&do=pointPurchaseSettings' ), 'saved' );
        }
		
		\IPS\Output::i()->sidebar['actions']['settings'] = array(
			'primary'	=> true,
			'icon'		=> 'cogs',
			'title'		=> 'ms_settings',
			'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings' ),
			'data'		=> array( )
		);	
			
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_nexus_purchase_settings' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function fm()
	{
		$emailRequest = \IPS\Request::i()->fm_copyright_removal_email ?: NULL;
		$refreshRequest = \IPS\Request::i()->fm_copyright_refresh ?: NULL;
		$extra = array();
		$extra['num'] = 13;
		$extra['que'] = 66;
		$extra['uni'] = 47;
		$jsonExtra = json_encode( $extra, true );
		
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_key' ] = 'License Key';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_key_desc' ] = 'Dont Have A Key? Purchase One <a target="_blank" rel="nofollow" href="https://flashmodding.com/index.php?/store/product/47-members-shop-copyright-removal/">Here</a> ( Opens In New Window )';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_email' ] = 'Identifier';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_removal_email_desc' ] = 'This is the email address you use for the account you purchased the copyright removal from';
		\IPS\Member::loggedIn()->language()->words[ 'fm_copyright_refresh' ] = 'Refresh Key';
		\IPS\Member::loggedIn()->language()->words[ 'fm_No' ] = 'No';
		\IPS\Member::loggedIn()->language()->words[ 'fm_No_desc' ] = 'I am adding the key for the first time';
		\IPS\Member::loggedIn()->language()->words[ 'fm_Yes' ] = 'Yes';
		\IPS\Member::loggedIn()->language()->words[ 'fm_Yes_desc' ] = 'Yes I need to refesh the key';
		
		$form = new \IPS\Helpers\Form;
		$form->class = 'ipsPad ipsBox ipsForm_fullWidth';
		$form->add( new \IPS\Helpers\Form\Text( 'fm_copyright_removal_key', NULL, TRUE, array( ), function( $val ) use ( $emailRequest, $refreshRequest, $jsonExtra )
		{
			if( $refreshRequest == 0 )
			{
				$url = 'https://flashmodding.com/applications/nexus/interface/licenses/branding.php?activate&key='.$val.'&identifier='.$emailRequest.'&extra='.$jsonExtra.'';
			}
			else
			{
				$url = 'https://flashmodding.com/applications/nexus/interface/licenses/branding.php?check&key='.$val.'&identifier='.$emailRequest.'&usage_id=1';
			}
			$response = \IPS\Http\Url::external( $url )->request()->get();
			$responseData = $response->decodeJson();
			
			if( $response->httpResponseCode != 200 )
			{
				throw new \DomainException( $responseData['errorCode'] );
			}			
		}
		) );
		$form->add( new \IPS\Helpers\Form\Email( "fm_copyright_removal_email", NULL, TRUE, array( ) ) );
		$form->add( new \IPS\Helpers\Form\Radio( "fm_copyright_refresh", NULL, FALSE, array( 'options' => array( 0 => 'fm_No', 1 => 'fm_Yes' ) ) ) );
		
		if( $values = $form->values(TRUE) )
		{
			unset( \IPS\Data\Store::i()->members_shop_cr );
			\IPS\Data\Store::i()->members_shop_cr = $values['fm_copyright_removal_key'];
			
			if( $values['fm_copyright_refresh'] == 0 )
			{
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings' ), 'License Key Accepted' );
			}
			else
			{
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings' ), 'License Key Refreshed' );
			}
		}
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'Copyright Removal' );
		\IPS\Output::i()->output = $form;
	}
}