<?php


namespace IPS\membersshop\modules\front\bank;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * main
 */
class _main extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		\IPS\Output::i()->jsVars['ms_flash_msg_pos'] = \IPS\Settings::i()->ms_flash_msg_pos;
		\IPS\Output::i()->globalControllers[] = 'membersshop.shop';
		\IPS\Output::i()->jsFiles = array_merge( \IPS\Output::i()->jsFiles, \IPS\Output::i()->js( 'global_shop.js', 'membersshop', 'global' ) );
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$member = \IPS\Member::loggedIn();
		
		if ( !$member->member_id )
		{
			\IPS\Output::i()->error( 'no_module_permission_guest', '2S147/1', 403, '' );
		}
		
		$group = \IPS\Member\Group::load( $member->member_group_id );
		
		if ( !$group->canBank() )
		{
			\IPS\Output::i()->error( 'ms_bank_perm_error', 'MEMBERSHOPBANKPERMISSION/1', 403, '' );
		}
		
		$interest = $group->bankInterest();
		$nextTask = \IPS\Db::i()->select( 'next_run', 'core_tasks', array( 'app=? AND `key`=?', 'membersshop', 'bankInterest' ) )->first();
		$points = number_format( $member->shopPoints() );
		$formMax = $member->shopPoints();
		
		try
		{
			$bank = \IPS\membersshop\Bank::load( $member->member_id, 'member_id' )->points;
			$bankMax = $bank;
		}
		catch( \Exception $e )
		{
			$bank = 0;
			$bankMax = 0;
		}
		$pointsName = \IPS\Settings::i()->ms_points_name;
		$myNumber = $bank;
		$percentToGet = $interest;
		$percentInDecimal = $percentToGet / 100;
		$toCome = number_format($percentInDecimal * $myNumber);
		$pointsName = \IPS\Settings::i()->ms_points_name;
		$deposit = new \IPS\Helpers\Form;
		$deposit->class = 'ipsForm_vertical';
		$deposit->actionButtons[0] = \IPS\Theme::i()->getTemplate( 'forms', 'core', 'global' )->button( 'ms_deposit', 'submit', null, 'ipsButton ipsButton_primary', array( 'tabindex' => '2', 'accesskey' => 's', 'data-action' => 'deposit' ) );
		$deposit->add( new \IPS\Helpers\Form\Number( 'ms_deposit_amount', $formMax, FALSE, array( 'min' => 100, 'max' => $formMax ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_points', FALSE, array( 'sprintf' => array( $pointsName ) ) ), 'ms_deposit_amount' ) );
		$message = \IPS\Member::loggedIn()->language()->addToStack('ms_charge_to_deposit', FALSE, array( 'sprintf' => array( number_format( $group->depositCost() ), $pointsName ) ) );
		$deposit->addHtml( '<div id="deposit_message" class="ipsType_warning" style="margin-left:0px;"></div>'.$message.'<br><br>' );
		$withdraw = new \IPS\Helpers\Form;
		$withdraw->class = 'ipsForm_vertical';
		$withdraw->actionButtons[0] = \IPS\Theme::i()->getTemplate( 'forms', 'core', 'global' )->button( 'ms_withdraw', 'submit', null, 'ipsButton ipsButton_primary', array( 'tabindex' => '2', 'accesskey' => 's', 'data-action' => 'withdraw' ) );
		$withdraw->add( new \IPS\Helpers\Form\Number( 'ms_withdraw_amount', $bankMax, FALSE, array( 'min' => 10, 'max' => $bankMax ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_points', FALSE, array( 'sprintf' => array( $pointsName ) ) ), 'ms_withdraw_amount' ) );
		$withdraw->addHtml( '<div id="withdraw_message" class="ipsType_warning"></div>'.\IPS\Member::loggedIn()->language()->addToStack( 'ms_withdrawals_are_free').'<br><br>' );		
		
		\IPS\Output::i()->jsVars['depositMinMax'] = \IPS\Member::loggedIn()->language()->addToStack('ms_deposit_min_max', FALSE, array( 'sprintf' => array( 100, number_format( $formMax ), $pointsName ) ) );
		\IPS\Output::i()->jsVars['depositMinAmount'] = \IPS\Member::loggedIn()->language()->addToStack('ms_deposit_min_amount', FALSE, array( 'sprintf' => array( 100, $pointsName ) ) );
		\IPS\Output::i()->jsVars['withdrawMinMax'] = \IPS\Member::loggedIn()->language()->addToStack('ms_withdraw_min_max', FALSE, array( 'sprintf' => array( 10, number_format( $bankMax ), $pointsName ) ) );
		\IPS\Output::i()->jsVars['withdrawMinAmount'] = \IPS\Member::loggedIn()->language()->addToStack('ms_withdraw_min_amount', FALSE, array( 'sprintf' => array( 10, $pointsName ) ) );
		
		if( $values = $deposit->values() AND $values['ms_deposit_amount'] )
		{
			try
			{
				$bank = \IPS\membersshop\Bank::load( $member->member_id, 'member_id' );
				$group = \IPS\Member\Group::load( $member->member_group_id );
				$myNumbers = $values['ms_deposit_amount'];
				$percentToGets = $group->depositCost();
				$percentInDecimals = $percentToGets / 100;
				$result = $percentInDecimals * $myNumbers;
				$Bankedpoints = $values['ms_deposit_amount'] - $result;
				$bank->points = $bank->points + $Bankedpoints;
			}
			catch( \Exception $e )
			{
				$bank = new \IPS\membersshop\Bank;
				$group = \IPS\Member\Group::load( $member->member_group_id );
				$myNumbers = $values['ms_deposit_amount'];
				$percentToGets = $group->depositCost();
				$percentInDecimals = $percentToGets / 100;
				$result = $percentInDecimals * $myNumbers;
				$Bankedpoints = $values['ms_deposit_amount'] - $result;
				$bank->points = $bank->points + $Bankedpoints;
			}
			$bank->member_id = $member->member_id;
			$bank->m_group_id = $member->member_group_id;
			$bank->save();
			
			$transaction = new \IPS\membersshop\Transactions;
			$transaction->member_id = $member->member_id;
			$transaction->amount = $values['ms_deposit_amount'] - $result;
			$transaction->transaction = 0;
			$transaction->charge = $result;
			$transaction->time_date = time();
			$transaction->balance = $bank->points;
			$transaction->save();			
			
			$pointsName = \IPS\Settings::i()->ms_points_name;
			$messageOne = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_deposit_charge'), $pointsName );
			$member->removePoints( $result, $messageOne );
			
			$messageTwo = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_banked'), $pointsName );
			$member->removePoints( $Bankedpoints, $messageTwo );
			
			$outputLang = ( number_format( $Bankedpoints ) ) ? \IPS\Member::loggedIn()->language()->addToStack('ms_banked_points', FALSE, array( 'sprintf' => array( number_format( $Bankedpoints ), $pointsName ) ) ) : 'Deposited';
			
			if ( \IPS\Request::i()->isAjax() )
			{
				\IPS\Output::i()->json( array(
					'message'   => $outputLang
				));
				return;
			}
			else
			{
				\IPS\Output::i()->redirect( \IPS\Request::i()->referrer() ?: \IPS\Http\Url::internal( 'app=membersshop&module=bank&controller=main', 'front', 'bank' ), $outputLang );
			}
		}
		elseif( $values = $withdraw->values() AND $values['ms_withdraw_amount'] )
		{
			try
			{
				$bank = \IPS\membersshop\Bank::load( $member->member_id, 'member_id' );
				$bank->points = $bank->points - $values['ms_withdraw_amount'];
			}
			catch( \Exception $e )
			{
				
			}
			
			$bank->member_id = $member->member_id;
			$bank->save();
			
			$pointsName = \IPS\Settings::i()->ms_points_name;
			$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_withdrew'), $pointsName );
			$member->addPoints( $values['ms_withdraw_amount'], $logsACP );
			
			$transaction = new \IPS\membersshop\Transactions;
			$transaction->member_id = $member->member_id;
			$transaction->amount = $values['ms_withdraw_amount'];
			$transaction->transaction = 1;
			$transaction->time_date = time();
			$transaction->balance = $bank->points;
			$transaction->save();		
			
			if ( \IPS\Request::i()->isAjax() )
			{
				\IPS\Output::i()->json( array(
					'message'   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_withdrawal_complete' )
				));
				return;
			}
			else
			{
				\IPS\Output::i()->redirect( \IPS\Request::i()->referrer() ?: \IPS\Http\Url::internal( 'app=membersshop&module=bank&controller=main', 'front', 'bank' ), \IPS\Member::loggedIn()->language()->addToStack( 'ms_withdrawal_complete' ) );
			}
		}
		else
		{
			\IPS\Output::i()->breadcrumb['module'] = array( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=main', 'front', 'membersshop' ), \IPS\Member::loggedIn()->language()->addToStack('__app_membersshop') );
			\IPS\Output::i()->breadcrumb[] = array( NULL, \IPS\Member::loggedIn()->language()->addToStack( 'module__membersshop_bank' ) );
		
			\IPS\Session::i()->setLocation( \IPS\Http\Url::internal( 'app=membersshop&module=bank&controller=main' ), array(), 'loc_ms_bank' );
			\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'menu__membersshop_bank' );
			
			if ( \IPS\Request::i()->isAjax() )
			{
				\IPS\Output::i()->json( array(
					'contents'  => \IPS\Theme::i()->getTemplate( 'bank', 'membersshop')->main( $deposit, $withdraw, $member, $points, $bank, $interest, $nextTask, $toCome )
				)) ;
				return;
			}
			else
			{
				\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'bank', 'membersshop')->main( $deposit, $withdraw, $member, $points, $bank, $interest, $nextTask, $toCome );
			}
		}		
	}
}