<?php


namespace IPS\membersshop\modules\front\logs;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * logs
 */
class _logs extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$member = \IPS\Member::loggedIn();
		$table = new \IPS\Helpers\Table\Db( 'membersshop_rewards', \IPS\Http\Url::internal( 'app=membersshop&module=logs&controller=logs', 'front', 'logs' ) );
		$table->include = array( 'item_id', 'member_id', 'time_date', 'reward', 'stolen_from', 'name', 'description', 'id' );
		if ( \IPS\Settings::i()->ms_logs_view_set == 0 )
		{
			$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate('logs', 'membersshop'), 'rows' );
		}
		else
		{
			if ( \IPS\Settings::i()->ms_grid_style == 0 )
			{
				$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate('logs', 'membersshop'), 'rowsGridMini' );
			}
			else
			{
				$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate('logs', 'membersshop'), 'rowsGrid' );
			}
		}
		$table->joins = array();
		$table->langPrefix = 'ms__';
		$table->limit = \IPS\Settings::i()->ms_rewards_table_limit;
		$table->title = 'ms_RewardsNlogs';		
		$table->filters = array(
			'my_logs' => array( 'member_id=?', $member->member_id ),
		);
		$table->filters['ms_filter_items'] = 'item_id!=-1 AND item_id!=-2 and item_id!=-3 and item_id!=-4 and item_id!=-5 and item_id!=-6 and item_id!=-7 and item_id!=-8 and item_id!=-9 and item_id!=-10 and item_id!=-11 and item_id!=-12 and item_id!=-13 and item_id!=-14 and item_id!=-15 and item_id!=5 and item_id!=16 and item_id!=17 and item_id!=10 and item_id!=21 and item_id!=-999';
		$table->filters['ms_filter_point_items'] = 'item_id=5 or item_id=10 or item_id=21';
		if( \IPS\Application::appIsEnabled( 'forums' ) )
		{
			$table->filters['ms_filter_forums']	= 'item_id=-2 OR item_id=-3 or item_id=-4 or item_id=-15';
		}
		if( \IPS\Application::appIsEnabled( 'downloads' ) )
		{
			$table->filters['ms_filter_downloads']	= 'item_id=-5 OR item_id=-6 OR item_id=-7 OR item_id=-8';
		}
		if( \IPS\Application::appIsEnabled( 'gallery' ) )
		{
			$table->filters['ms_filter_gallery']	= 'item_id=-20 OR item_id=-21 OR item_id=-22';
		}
		if( \IPS\Application::appIsEnabled( 'calendar' ) )
		{
			$table->filters['ms_filter_calendar']	= 'item_id=-9 OR item_id=-10 OR item_id=-11';
		}
		if( \IPS\Application::appIsEnabled( 'nexus' ) )
		{
			$table->filters['ms_filter_nexus']	= 'item_id=-14';
		}
		if( \IPS\Application::appIsEnabled( 'rules' ) )
		{
			$table->filters['ms_filter_rules']	= 'item_id=-999';
		}
		$table->filters['ms_filter_statuses']	= 'item_id=-12 or item_id=-13';
		$table->filters['ms_filter_reactions']	= 'item_id=-1';
		$table->sortBy = $table->sortBy ?: 'time_date';
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('ms_RewardsNlogs');
		\IPS\Output::i()->breadcrumb['module'] = array( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=main', 'front', 'membersshop' ), \IPS\Member::loggedIn()->language()->addToStack('__app_membersshop') );
		\IPS\Output::i()->breadcrumb[] = array( NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_logs') );
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate('logs', 'membersshop')->template( (string) $table );
	}
	
	protected function rewardLog()
	{
		$id  = \intval( \IPS\Request::i()->id );
		$rewardLog = \IPS\membersshop\Rewards::load( $id );
		$reward = sprintf( \IPS\Member::loggedIn()->language()->get( 'ms_log_posts' ), $rewardLog->reward, $rewardLog->name  );
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'logs', 'membersshop' )->rewardLog( $reward );
	}
}