<?php


namespace IPS\membersshop\modules\front\shop;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * view
 */
class _view extends \IPS\Content\Controller
{
	
	protected static $contentModel = 'IPS\membersshop\Shopitems';
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		try
		{
			$this->item = \IPS\membersshop\Shopitems::load( \IPS\Request::i()->id );
		}
		catch ( \OutOfRangeException $e )
		{
			\IPS\Output::i()->error( 'node_error', 'MembersShopView/1', 404, '' );
		}
		
		\IPS\Output::i()->jsVars['ms_flash_msg_pos'] = \IPS\Settings::i()->ms_flash_msg_pos;
		\IPS\Output::i()->globalControllers[] = 'membersshop.shop';
		\IPS\Output::i()->jsFiles = array_merge( \IPS\Output::i()->jsFiles, \IPS\Output::i()->js( 'global_shop.js', 'membersshop', 'global' ) );
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		parent::manage();
		
		$member = \IPS\Member::loggedIn();
		$pointsName = \IPS\Settings::i()->ms_points_name;
		$points = $member->shopPoints();
		$url = $this->item->container()->url();
		$categories = \IPS\membersshop\Categories::roots();
		
		if ( \IPS\Request::i()->isAjax() )
		{
			\IPS\Output::i()->json( array(
				'contents' 	=> \IPS\Theme::i()->getTemplate( 'shop' )->view( $this->item, $pointsName, $member, $points ),
				'sidebar'	=> \IPS\Theme::i()->getTemplate( 'shop' )->indexSidebar( $categories, $url )
			)) ;
			return;
		}
		else
		{
			\IPS\Output::i()->title = $this->item->name;
			\IPS\Output::i()->sidebar['contextual'] = \IPS\Theme::i()->getTemplate( 'shop' )->indexSidebar( $categories, $url );
			\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'shop' )->view( $this->item, $pointsName, $member, $points );
		}
	}
}