<?php


namespace IPS\membersshop\setup\upg_11004;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 1.1.4 Upgrade Code
 */
class _Upgrade
{
	/**
	 * ...
	 *
	 * @return	array	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step1()
	{
		foreach( \IPS\Db::i()->select( '*', 'core_groups', array( 'g_id IS NOT NULL' ) ) as $groups )
		{
			try
			{
				$setGroups = new \IPS\membersshop\Groups;
				$setGroups->group_id = $groups['g_id'];
				$setGroups->can_bank = $groups['ms_can_bank'];
				$setGroups->daily_points = $groups['ms_daily_points'];
				$setGroups->weekly_points = $groups['ms_weekly_points'];
				$setGroups->monthly_points = $groups['ms_monthly_points'];
				$setGroups->deposit_cost = $groups['ms_deposit_cost'];
				$setGroups->bank_interest = $groups['ms_bank_interest'];
				$setGroups->save();
			}
			catch( \Exception $e ){}
		}
		return TRUE;
	}
	
	public function step2()
	{
		foreach( \IPS\Db::i()->select( '*', 'core_reactions', array( 'reaction_id IS NOT NULL' ) ) as $reactions )
		{
			try
			{
				$reaction = new \IPS\membersshop\Reactions;
				$reaction->reaction_id = $reactions['reaction_id'];
				$reaction->points = $reactions['reaction_shop_points'];
				$reaction->save();
			}
			catch( \Exception $e ){}
		}
		return TRUE;
	}
	
	public function step3()
	{
		foreach( \IPS\Db::i()->select( '*', 'core_members_warn_reasons', array( 'wr_id IS NOT NULL' ) ) as $warnings )
		{
			try
			{
				$warning = new \IPS\membersshop\Warnings;
				$warning->reason_id = $warnings['wr_id'];
				$warning->points = $warnings['wr_ms_warn_points'];
				$warning->save();
			}
			catch( \Exception $e ){}
		}
		return TRUE;
	}
	
	// You can create as many additional methods (step2, step3, etc.) as is necessary.
	// Each step will be executed in a new HTTP request
}