<?php

namespace IPS\membersshop;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _Purchases extends \IPS\Patterns\ActiveRecord
{
    
    /**
     * @brief    [ActiveRecord] Multiton Store
     */
    protected static $multitons;

    /**
     * @brief    [ActiveRecord] Database table
     */
    public static $databaseTable = 'membersshop_purchases';

    /**
     * @brief    [ActiveRecord] Database Prefix
     */
    public static $databasePrefix = '';

    /**
     * @brief    [ActiveRecord] ID Database Column
     */
    public static $databaseColumnId = 'id';

    /**
     * @brief    [ActiveRecord] Database ID Fields
     */
    protected static $databaseIdFields = [ 'id', 'member_id', 'redeemed', 'item_id', 'time_date' ];

	public static function count()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$count = \IPS\Db::i()->select( 'COUNT(*)', 'membersshop_purchases', array( 'member_id=? AND redeemed=? AND item_id=?', $member, 0, 11 ) )->first();
		return $count;
	}
	
	public static function pinTopic()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$pinTopic = \IPS\Db::i()->select( 'id', 'membersshop_purchases', array( 'member_id=? AND redeemed=? AND item_id=?', $member, 0, 11 ) )->first();
		return $pinTopic;
	}
	
	public static function fcount()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$count = \IPS\Db::i()->select( 'COUNT(*)', 'membersshop_purchases', array( 'member_id=? AND redeemed=? AND item_id=?', $member, 0, 12 ) )->first();
		return $count;
	}
	
	public static function featureFile()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$pinTopic = \IPS\Db::i()->select( 'id', 'membersshop_purchases', array( 'member_id=? AND redeemed=? AND item_id=?', $member, 0, 12 ) )->first();
		return $pinTopic;
	}
	
	public function hasSettings()
	{
		if( \in_array( $this->item_id, array( 3, 4, 6, 8, 9, 10, 19, 21, 22, 23, 24, 25 ) ) )
		{
			return TRUE;
		}
		return FALSE;
	}
}