<?php

namespace IPS\membersshop;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _Rewards extends \IPS\Patterns\ActiveRecord
{
    
    /**
     * @brief    [ActiveRecord] Multiton Store
     */
    protected static $multitons;

    /**
     * @brief    [ActiveRecord] Database table
     */
    public static $databaseTable = 'membersshop_rewards';

    /**
     * @brief    [ActiveRecord] Database Prefix
     */
    public static $databasePrefix = '';

    /**
     * @brief    [ActiveRecord] ID Database Column
     */
    public static $databaseColumnId = 'id';

    /**
     * @brief    [ActiveRecord] Database ID Fields
     */
    protected static $databaseIdFields = [ 'id', 'member_id', 'reward', 'item_id' ];

	public function getLog()
	{
		$pointsName = \IPS\Settings::i()->ms_points_name;
		
		if ( $this->item_id == 1 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_random_post_count'), number_format( $this->reward ), $this->name );
		}
		elseif ( $this->item_id == 2 )
		{
			return  sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_reputation_count'), number_format( $this->reward ), $this->name );
		}
		elseif ( $this->item_id == 3 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_stole_reputation'), number_format( $this->reward ), $this->name );
		}
		elseif ( $this->item_id == 4 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_changed_their_username");
		}
		elseif ( $this->item_id == 5 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_gamble_points'), number_format( $this->reward ), $pointsName, $this->name );
		}
		elseif ( $this->item_id == 6 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_changed_their_title");
		}
		elseif ( $this->item_id == 7 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_reset_their_warning_points");
		}
		elseif ( $this->item_id == 8 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_gained_forums_password");
		}
		elseif ( $this->item_id == 9 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_changed_added_their_signature");
		}
		elseif ( $this->item_id == 10 )
		{
			if ( $this->reward )
			{
				return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_won_rock_paper'), number_format( $this->reward ), $pointsName, $this->name );
			}
			else
			{
				return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_lost_rock_paper'), $this->name );
			}
		}
		elseif ( $this->item_id == 11 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_pinned_a_topic");
		}
		elseif ( $this->item_id == 12 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_featured_a_file");
		}
		elseif ( $this->item_id == 13 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_upgraded_their_usergroup");
		}
		elseif ( $this->item_id == 14 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_upgraded_their_usergroup");
		}
		elseif ( $this->item_id == 15 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_upgraded_their_usergroup");
		}
		elseif ( $this->item_id == 16 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_gamble_points'), number_format( $this->reward ), $pointsName, $this->name );
		}
		elseif ( $this->item_id == 17 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_gamble_points'), number_format( $this->reward ), $pointsName, $this->name );
		}
		elseif ( $this->item_id == 18 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_won_a_trophy");
		}
		elseif ( $this->item_id == 19 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_changed_added_avatar");
		}
		elseif ( $this->item_id == 21 )
		{
			if ( $this->reward )
			{
				return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_won_guess_number'), number_format( $this->reward ), $pointsName, $this->name );
			}
			else
			{
				return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_lost_guess_number'), $this->name );
			}
		}
		elseif ( $this->item_id == 22 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_changed_profile_video");
		}
		elseif ( $this->item_id == 23 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_changed_profile_background");
		}
		elseif ( $this->item_id == 24 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_sent_sticky_note");
		}
		elseif ( $this->item_id == 25 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_edited_social_info");
		}
		elseif ( $this->item_id == 27 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_purchased_a_trophy");
		}
		elseif ( $this->item_id == 28 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_purchased_a_medal");
		}
		elseif ( $this->item_id == 29 )
		{
			return \IPS\Member::loggedIn()->language()->get("ms_log_reset_their_rep_points");
		}
		elseif ( $this->item_id == 30 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_won_mystery_item'), $this->extra_field, $this->name );
		}
		elseif ( $this->item_id == -1 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_reaction'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -2 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_topic_created'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -3 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_topic_reply'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -4 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_topic_reply_starter'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -5 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_file_download'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -6 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_file_upload'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -7 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_file_review'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -8 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_file_comment'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -9 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_calendar_event'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -10 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_calendar_comment'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -11 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_calendar_review'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -12 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_status_create'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -13 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_status_reply'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -14 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_nexus_review'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -15 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_best_answer'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -20 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_gallery_upload'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -21 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_gallery_comment'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -22 )
		{
			return sprintf( \IPS\Member::loggedIn()->language()->get('ms_log_gallery_review'), number_format( $this->reward ), $pointsName );
		}
		elseif ( $this->item_id == -999 )
		{
			return ''.\IPS\Member::loggedIn()->language()->get("ms_gained").' '.number_format( $this->reward ).' '.$pointsName.' '.$this->description.'';
		}
		else
		{
			return '';
		}
	}
}