<?php

namespace IPS\membersshop;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _Upgrades extends \IPS\Patterns\ActiveRecord
{
    
    /**
     * @brief    [ActiveRecord] Multiton Store
     */
    protected static $multitons;

    /**
     * @brief    [ActiveRecord] Database table
     */
    public static $databaseTable = 'membersshop_upgrades';

    /**
     * @brief    [ActiveRecord] Database Prefix
     */
    public static $databasePrefix = '';

    /**
     * @brief    [ActiveRecord] ID Database Column
     */
    public static $databaseColumnId = 'id';

    /**
     * @brief    [ActiveRecord] Database ID Fields
     */
    protected static $databaseIdFields = [ 'id', 'member_id', 'original_group', 'reward_group', 'time_date', 'expired' ];

	public static function count()
	{
		$member = \IPS\Member::loggedIn()->member_id;
		$count = \IPS\Db::i()->select( 'COUNT(*)', 'membersshop_upgrades', array( 'member_id=? AND expired=?', $member, 0 ) )->first();
		return $count;
	}
	
}